
#include "fxengine.h"
#include "fxobject.h"
#include "textobject.h"

fxeObjectHandle fxeTextObjectCreate(fxeTextureHandle TH, float Width,
  float Height, float x, float y, float z)
{
  fxeObject *pObject;

  pObject = (fxeObject*)malloc(sizeof(fxeObject));

  pObject->NumPolys = 1;
  pObject->NumVertices = 4;
  pObject->ShadingType = FLAT_SHADING;
  pObject->Transparent = FXETRUE;
  pObject->LowAccuracyLightning = FXEFALSE;
  pObject->x = x;
  pObject->y = y;
  pObject->z = z;

  pObject->VertexList = (fxeVertex*)malloc(sizeof(fxeVertex)*4);
  pObject->PolygonList = (fxePolygon*)malloc(sizeof(fxePolygon));
  pObject->VerticesWorld = (fxeVertex*)malloc(sizeof(fxeVertex)*4);
  pObject->VerticesCamera = (fxeVertex*)malloc(sizeof(fxeVertex)*4);
  pObject->VertexColors = (fxeColor*)malloc(sizeof(fxeColor)*4);
  pObject->ProjectedVertices = (fxeVertex*)malloc(sizeof(fxeVertex)*4);

  pObject->VertexList[0].x = -Width/2;
  pObject->VertexList[0].y = Height/2;
  pObject->VertexList[0].z = 0;

  pObject->VertexList[1].x = -Width/2;
  pObject->VertexList[1].y = -Height/2;
  pObject->VertexList[1].z = 0;

  pObject->VertexList[2].x = Width/2;
  pObject->VertexList[2].y = -Height/2;
  pObject->VertexList[2].z = 0;

  pObject->VertexList[3].x = Width/2;
  pObject->VertexList[3].y = Height/2;
  pObject->VertexList[3].z = 0;

  pObject->PolygonList[0].VertexIndices = (fxeVertexIndex*)malloc(sizeof(
    fxeVertexIndex)*4);
  pObject->PolygonList[0].VertexIndices[0] = 0;
  pObject->PolygonList[0].VertexIndices[1] = 1;
  pObject->PolygonList[0].VertexIndices[2] = 2;
  pObject->PolygonList[0].VertexIndices[3] = 3;
  pObject->PolygonList[0].NumVertices = 4;

  pObject->PolygonList[0].TexMode = TEXTURE_MAPPED;
  pObject->PolygonList[0].TextureCoordinates = (fxeTextureCoordinate*)
    malloc(sizeof(fxeTextureCoordinate)*4);

  pObject->PolygonList[0].TextureCoordinates[0].s = 0;
  pObject->PolygonList[0].TextureCoordinates[0].t = 0;
  pObject->PolygonList[0].TextureCoordinates[1].s = 0;
  pObject->PolygonList[0].TextureCoordinates[1].t = 256;
  pObject->PolygonList[0].TextureCoordinates[2].s = 256;
  pObject->PolygonList[0].TextureCoordinates[2].t = 256;
  pObject->PolygonList[0].TextureCoordinates[3].s = 256;
  pObject->PolygonList[0].TextureCoordinates[3].t = 0;

  pObject->PolygonList[0].ConstantColor.r = 255;
  pObject->PolygonList[0].ConstantColor.g = 255;
  pObject->PolygonList[0].ConstantColor.b = 255;
 
  pObject->PolygonList[0].ClippedVertices = (fxeVertex*)malloc(sizeof(
    fxeVertex)*8);
  pObject->PolygonList[0].ClippedVertexColors =
    (fxeColor*)malloc(sizeof(fxeColor)*8);
  pObject->PolygonList[0].ClippedTextureCoordinates = (fxeTextureCoordinate*)
    malloc(sizeof(fxeTextureCoordinate)*8);

  pObject->PolygonList[0].TexMode = TEXTURE_MAPPED;
  pObject->PolygonList[0].TextureHandle = TH;
  pObject->PolygonList[0].DoubleSided = FXETRUE;
  pObject->PolygonList[0].Transparent = FXETRUE;
  pObject->PolygonList[0].PolygonRadius = GetMaximumRadius(pObject);
  pObject->PolygonList[0].AlphaLevel = 255;
  pObject->ObjectRadius = GetMaximumRadius(pObject);
  return pObject;
}
 
void fxeTextObjectSetTransparency(fxeObjectHandle pObject, float AlphaValue)
{
  pObject->PolygonList[0].AlphaLevel = AlphaValue;
}
